class CurrencyQuote::InvertirOnline
	require 'httparty'

	attr_accessor :username, :password, :access_token

	BASE_URL = "https://api.invertironline.com"

	def initialize(username:, password:)
		@username = username
		@password = password
		get_token
	end

	def get_quote(simbol:, mercado: 'bCBA', plazo: 't1')
		url = BASE_URL + "/api/v2/#{mercado}/Titulos/#{simbol.upcase}/Cotizacion"
		HTTParty.get(url,
			body: {
				'mercado' => mercado,
				'simbol' => simbol.upcase,
				'model.mercado' => mercado,
				'model.plazo' => plazo
			},
			headers: {
			'Authorization' => "Bearer #{@access_token}",
			'Accept' => 'application/json'
			}
		).parsed_response
	end

	private

		def get_token
			url = BASE_URL + "/token"
			@access_token =  HTTParty.post(url, 
				body: {
					username: username,
					password: password,
					grant_type: 'password'
				},
				headers:{
					'Content-Type' => 'application/x-www-form-urlencoded',
					'Accept' => 'application/json'
				}
			)['access_token']
		end
end